-- Copyright (c) 2011, Pedro Ignacio Martos <pmartos@fi.uba.ar / pimartos@gmail.com> & Fabricio Baglivo <baglivofabricio@gmail.com>
-- All rights reserved.
--  
-- Redistribution and use in source and binary forms, with or without modification, are permitted provided that
-- the following conditions are met:
-- 
--     * Redistributions of source code must retain the above copyright notice, this list of conditions and the 
--       following disclaimer.
--     * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and 
--       the following disclaimer in the documentation and/or other materials provided with the distribution.
-- 
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
-- INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
-- DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
-- SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
-- SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
-- WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE 
-- USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity SyncReset is
    Port ( clock : in  STD_LOGIC;
           ExtReset : in  STD_LOGIC;
           ResetPulse : out  STD_LOGIC);
end SyncReset;


architecture Behavioral of SyncReset is

--component Constant2Pulse is
--    Port ( Clock : in  STD_LOGIC;
--           Pulse : out  STD_LOGIC);
--end component;

--signal ExtResetDelayed : std_logic; 
--signal trigger1 : std_logic;

--signal trigger : std_logic;
signal QD0 : std_logic;
signal QD1 : std_logic;
signal QD2 : std_logic;
signal QD3 : std_logic;


begin


--instconst2pulse : Constant2Pulse
--		port map ( Clock => Clock,
--           Pulse => trigger1);


instD0 : FDCE
		generic map (
			INIT => '0') -- Initial value of register ('0' or '1')
		port map (
		Q => QD0, -- Data output
		C => clock, -- Clock input
		CE => '1', -- Clock enable input
		CLR => '0', -- Asynchronous clear input
		--D => '0'-- Data input
		D => ExtReset
		);

instD1 : FDCE
		generic map (
			INIT => '0') -- Initial value of register ('0' or '1')
		port map (
		Q => QD1, -- Data output
		C => clock, -- Clock input
		CE => '1', -- Clock enable input
		CLR => '0', -- Asynchronous clear input
		D => QD0 -- Data input
		);
instD2 : FDCE
		generic map (
			INIT => '0') -- Initial value of register ('0' or '1')
		port map (
		Q => QD2, -- Data output
		C => clock, -- Clock input
		CE => '1', -- Clock enable input
		CLR => '0', -- Asynchronous clear input
		D => QD1 -- Data input
		);
instD3 : FDCE
		generic map (
			INIT => '0') -- Initial value of register ('0' or '1')
		port map (
		Q => QD3, -- Data output
		C => clock, -- Clock input
		CE => '1', -- Clock enable input
		CLR => '0', -- Asynchronous clear input
		D => QD2 -- Data input
		);

ResetPulse <= not (ExtReset or QD0 or QD1 or QD2 or QD3);


	
end Behavioral;

