module loop_cache #(parameter ADDRWIDTH=2)
(
input wire clk,
input  wire n_reset,
input wire htrans,
input wire enable_cache,
input wire write_enable,
input wire [31:0] data_in,
input wire [ADDRWIDTH-1:0] address,
output  reg [31:0] data_out
);

integer i;
(* mark_debug = "true" *) reg htrans_a;
(* mark_debug = "true" *) reg [ADDRWIDTH-1:0] address_a;
(* mark_debug = "true" *) reg [31:0] cache [2**ADDRWIDTH-1:0];
                 
//ADDRESS phase 
always @(posedge clk ,negedge n_reset)
begin
	if (~n_reset)
		begin
		address_a <= 4'b0000;
		data_out<= 32'h00000000;
		for (i=0; i<2**ADDRWIDTH; i=i+1)
		cache[i] <= 32'h00000000;
		end
	else
		begin
		htrans_a<=htrans;
		address_a<=address;
		if (write_enable&& htrans_a)
			cache[address_a] <= data_in;// fill
        //if (enable_cache && htrans_a)
		if (enable_cache && htrans)	
			data_out<=cache[address];
		end
end
endmodule