# -*- coding: utf-8 -*-
"""
Created on Sun Mar 29 05:03:07 2015

@author: Dell
"""
#!/usr/bin/env python2

# -----------------------------------------------------------------------------

import sys
import csv

def Simulate(dataSet, cache_size ):
####### states:
#IDLE:         0
#PSEUDO_IDLE:   1
#COUNT:         2
#PSEUDO_COUNT:  3
#FILL:          4
#PSEUDO_FILL:   5
#ACTIVE:        6
#PSEUDO_ACTIVE: 7
      
  readpwrs = {}
  writepwrs = {}
  flashpwr = 180 
  
  readpwrs[16] = 1.875
  writepwrs[16] = 2.5
  readpwrs[32] = 3.75
  writepwrs[32] = 5
  readpwrs[64] = 7.5
  writepwrs[64] = 10
  readpwrs[128] = 15
  writepwrs[128] = 20
  readpwrs[256] = 17
  writepwrs[256] = 24
  readpwrs[384] = 19
  writepwrs[384] = 28
  readpwrs[512] = 21
  writepwrs[512] = 30
  readpwrs[640] = 23
  writepwrs[640] = 34
  readpwrs[768] = 25
  writepwrs[768] = 37
  readpwrs[896] = 27
  writepwrs[896] = 41
  readpwrs[1024] = 28
  writepwrs[1024] = 44
  readpwrs[1536] = 35
  writepwrs[1536] = 42
  readpwrs[2048] = 37
  writepwrs[2048] = 46
  readpwrs[4096] = 37
  writepwrs[4096] = 46
  sram_reads  = 0
  sram_writes = 0
  valid = 0
  hit_rate = 0
  rw_ratio = 0
  old = 0
  old_old = 0
  new = 0
  position = 0
  

  state = 0

  cache = []
  counter = 0
  loop_size = 0
  times_executed = 0
  firsts=[]
  sbbs=[]
  loop_sz=[]
  inst_no=[]
  times_ex=[]
  sbb = 0
  first = 0
  nextstate = 0
  flash_reads = 0
  

  # Open dataSet
  try:
    file = open(dataSet,'r')
  except:
    sys.stderr.write('Could not open dataSet\n')
    sys.exit()

  # Skip the first line in file (header)
  file.readline()

  # ---------------------------------------------------------------------------
  # Each line contains one address

  for line in file:
    position=position+1
    # Split out the address, ignore time for now
    try:
      [timeString, addrHex ] = line.split(',')
    except:
      sys.stderr.write('Bad: '+line+"\n")
      continue

    try:
      a = int(addrHex, 16)
      #print a
      if (a > 0) and (a < 536870911):
        # don't save idles and dummy values as last address
        valid = valid + 1
        old_old = old
        old = new
        new = a
      else:
        # Ignore idles
        continue
    except:
      sys.stderr.write('Could not convert %s to int\n' % addrHex)
      continue
  
    if (valid == 1):
        old_old = a
        old = a
        new = a

    if state == 0: # idle state
        cache = [] 
        if (new == old+4): # idle => idle
            nextstate = 0
            flash_reads = flash_reads + 1
        else: # idle => count
            if (new < old):
                nextstate = 2
                sbb = old
                first = new
                counter = 1
                flash_reads = flash_reads + 1
            else: # idle => pseudo_idle
                nextstate = 1
                flash_reads = flash_reads + 1
            
    if state == 1: # PSEUDO_IDLE
        if (new == old + 4) or (new == old_old + 4): # pseudo_idle => idle
            old = old_old 
            nextstate = 0
            flash_reads = flash_reads + 1
        else:
            if (new < old): # pseudo_idle => count
                nextstate = 2
                sbb = old
                first = new
                counter = 1
                flash_reads = flash_reads + 1
            else: # stay pseudo_idle
                nextstate = 1 
                flash_reads = flash_reads + 1

                
    if state == 2: # COUNT
        if (new == old + 4) and (new <= sbb): 
            nextstate = 2  # stay in count
            counter = counter + 1
            flash_reads=flash_reads + 1
        else:
            if (new > old + 4):
                nextstate = 3 # count => pseudo_count
                flash_reads=flash_reads + 1
            else:
                if (new == first) and (old == sbb) and (counter <= cache_size): # count => fill
                    nextstate = 4 
                    sram_writes = sram_writes + 1
                    loop_size = counter
                    counter = 1
                    cache. append (new)
                    flash_reads = flash_reads + 1
                else: # count => idle 
                    nextstate = 0
                    flash_reads=flash_reads + 1
                    counter = 0
        
    if state == 3: # PSEUDO_COUNT
        if (new == old_old + 4): # pseudo_count => count
            old = old_old
            counter = counter + 1 
            nextstate = 2
            flash_reads = flash_reads + 1
        else:
            if (new == first) and (old_old == sbb) and (counter <= cache_size):  # pseudo_count => fill
                nextstate = 4 
                sram_writes = sram_writes + 1
                old = old_old
                loop_size = counter
                cache. append (new)
                flash_reads = flash_reads + 1
            else:  # pseudo_count => idle
                nextstate = 0
                flash_reads = flash_reads + 1
                counter = 0
                
    if state == 4: # FILL
        if (new == old + 4) and (new <= sbb) and (counter < loop_size) :            
            nextstate = 4   # fill => fill            
            counter = counter + 1
            sram_writes=sram_writes + 1
            cache. append (new)
            flash_reads = flash_reads + 1
        else:
            if (new > old + 4): # fill => pseudo_fill 
                nextstate = 5 
                flash_reads=flash_reads + 1
            else:
                if (new == first) and (old == sbb) and (counter == loop_size):  # fill => active 
                    nextstate = 6 
                    sram_reads = sram_reads + 1
                    counter = 1
                    loop_sz.append(loop_size)
                else:
                    nextstate = 0
                    flash_reads=flash_reads + 1
                    counter = 0
                
    if state == 5: # PSEUDO_FILL
        if (new == old_old + 4) and (counter < loop_size): # pseudo_fill=> fill
            old = old_old
            nextstate = 4  
            counter = counter + 1
            flash_reads = flash_reads + 1
            sram_writes = sram_writes + 1
            cache. append (new)
        else:
            if (new == first) and (old_old == sbb) and (counter == loop_size): # pseudo_fill => active
                nextstate = 6 
                sram_reads = sram_reads+1
                old = old_old
                counter = 1
                loop_sz.append(loop_size)
            else: # pseudo_fill => idle
                nextstate = 0
                flash_reads = flash_reads + 1
                counter = 0
                
    if state == 6: # ACTIVE
        if (new == old + 4) and (new <= sbb): # stay in active
            sram_reads=sram_reads + 1
            nextstate = 6
            counter = counter + 1            
            if (new not in cache): # sanity check
                  print("1. Tried to read from cache, but value not there")
                  print new
                  print cache
                  sys.exit()            
        else:
            if (new == first) and (old == sbb) and (counter == loop_size): # stay in active but it is the begining of the loop again
                sram_reads=sram_reads + 1
                nextstate = 6
                counter = 1
                times_executed = times_executed + 1
                if (new not in cache): # sanity check
                      print("1. Tried to read from cache, but value not there")
                      print new
                      print cache
                      sys.exit()                  
            else:
                if (new > old + 4):   # ACTIVE => pseudo_active 
                    nextstate = 7 
                    flash_reads=flash_reads + 1
                else:    # ACTIVE => idle
                    nextstate = 0
                    flash_reads=flash_reads + 1
                    counter = 0
                    loop_sz.append(loop_size)
                    times_ex.append(times_executed)
                    sbbs.append(sbb)
                    firsts.append(first)
                    inst_no.append(position)

    if state == 7: # PSEUDO_ACTIVE
        if (new == old_old + 4) and (new <= sbb) and (counter < loop_size ):  # pseudo_active => active
            old = old_old
            nextstate = 6
            counter = counter + 1
            sram_reads = sram_reads + 1      
        else:
            if (new == first and old_old == sbb) and (counter == loop_size ):   # pseudo_active => active but begining of the loop again          
                nextstate = 6
                counter = 1
                sram_reads = sram_reads + 1
                times_executed = times_executed + 1
            else:   # pseudo_active => idle
                nextstate = 0
                flash_reads=flash_reads + 1    
                counter = 0 
                loop_sz.append(loop_size)
                times_ex.append(times_executed)
                sbbs.append(sbb)
                firsts.append(first)
                inst_no.append(position)
                
    state = nextstate
  file.close()

#  print writes, 
#  print " ",
#  print (writes * 100.0)/accesses
#  print reads,
#  print " ",
#  print (reads * 100.0)/accesses,
#  print " ",
#  if writes > 0:
#    print (reads *1.0/writes)
#  else:
#    print 0.0
#  print accesses
#  print size,
#  print ", ",
#  print (reads * 100.0) / accesses,
#  print ", ",
#  if writes > 0:
#    print (reads * 1.0 / writes)
#  else:
#    print "0.0"
    
  power_nocache=(flash_reads + sram_reads)*flashpwr
  power_withcache=flash_reads*flashpwr + sram_reads*readpwrs[cache_size*4] + sram_writes*writepwrs[cache_size*4]
  hit_rate=sram_reads/float(flash_reads + sram_reads)
  rw_ratio=sram_reads/float(sram_writes)
  x=power_withcache/float(power_nocache)
  power_savings = 1.0 - x  
  #result='results_final_' + cache_size + dataSet
  result='results_final_' + str(cache_size) + dataSet
  with open(result, 'wb') as result_file:    
    csv_writer = csv.writer(result_file)
    for row in range (1):

       csv_writer.writerow([sram_writes] + ['SRAM Writes:'])
       csv_writer.writerow([sram_reads] + ['SRAM Reads:'])
       csv_writer.writerow([flash_reads] + ['Flash reads:'])
       csv_writer.writerow([' '])
       csv_writer.writerow(['Loop size:'] + loop_sz)
       csv_writer.writerow(['Times executed:'] + times_ex)
       csv_writer.writerow(['First:'] + firsts)
       csv_writer.writerow(['Sbb:'] + sbbs)
       csv_writer.writerow(['Last instruction of the loop (its row in dataset) read from SRAM:'] + inst_no)
       csv_writer.writerow([cache_size] + ['Cache size'] )
       csv_writer.writerow([power_nocache] + ['Total Power With No Cache'] )
       csv_writer.writerow([power_withcache] + ['Total Power With Cache'] )
       csv_writer.writerow([power_savings] + ['Power Savings'] )
       csv_writer.writerow([hit_rate] + ['Hit Rate:'] )
       csv_writer.writerow([rw_ratio] + ['RW Ratio'] )
  result_file.close()                

datasets = ["coremark.csv", "primes.csv", "dijkstra.csv", "emlcd.csv", "preamp.csv", "sha.csv", "touch.csv"]

#datasets = ["coremark.csv"]

for d in datasets:
  print d
  for size in [4,6,8,10,12,14,16,18,20,22,24,26,28,30,32]:
      Simulate(d, size)

